## wiggle 0.6

=== Makefile ===

# Note on my Mobile Pentium II, -march=pentium2 delivers twice the performance of i386
#OptDbg=-O3
#OptDbg=-O3 -march=pentium2
OptDbg=-ggdb
CFLAGS=$(OptDbg) -Wall -Werror

# STRIP = -s
INSTALL = /usr/bin/install
DESTDIR = 
BINDIR  = /usr/bin
MANDIR  = /usr/share/man
MAN1DIR = $(MANDIR)/man1
MAN5DIR = $(MANDIR)/man5

all: wiggle wiggle.man test


wiggle : wiggle.o load.o split.o extract.o diff.o bestmatch.o ReadMe.o merge.o
wiggle.o load.o split.o extract.o diff.o bestmatch.o ReadMe.o merge.o : wiggle.h

test: wiggle dotest
	sh dotest

wiggle.man : wiggle.1
	nroff -man wiggle.1 > wiggle.man

clean:
	rm -f *.o *.man wiggle .version* version
	find . -name core -o -name '*.tmp*' -o -name .tmp | xargs rm -f

install : wiggle wiggle.1
	$(INSTALL) -D $(STRIP) -m 755 wiggle $(DESTDIR)$(BINDIR)/wiggle
	$(INSTALL) -D -m 644 wiggle.1 $(DESTDIR)$(MAN1DIR)/wiggle.1

version : ReadMe.c wiggle.1
	@rm -f version
	@sed -n -e 's/.*wiggle - v\([0-9.]*\) - .*/\1/p' ReadMe.c > .version-readme
	@sed -n -e 's/.*WIGGLE 1 "" v\([0-9.]*\)$$/\1/p' wiggle.1 > .version-man
	@cmp -s .version-readme .version-man && cat .version-man > version || { echo Inconsistant versions.; exit 1;}

dist : test clean version
	mkdir -p DIST
	rm -f DIST/wiggle-`cat version`
	ln -s .. DIST/wiggle-`cat version`
	tar czvf DIST/wiggle-`cat version`.tar.gz -h -C DIST --exclude RCS --exclude DIST wiggle-`cat version`
	rm -f DIST/wiggle-`cat version`

v : version
	cat version

## wiggle 0.8

=== debian/changelog ===
wiggle (0.8-1) unstable; urgency=low

  * New upstream release
    - Manual page hyphens (Closes: #574576).
    - Gcc 4.4 pointer initialization with NULL (Closes: #574577)
    - Strange bogus conflict (Closes: #271766)
  * debian/control
    - (Build-Depends): Add libncurses5-dev.
  * debian/patches
    - Remove those integrated to upstream.
    - (10): Fix spelling.
    - (20): Fix include.
  * debian/watch
    - Add URL.
  * debian/rules
    - Simplify even further.
    - (binary-arch): delete.
    - (override_dh_installchangelogs): add.

 -- Jari Aalto <jari.aalto@cante.net>  Tue, 11 May 2010 09:43:43 +0300

wiggle (0.6.20100304+git1c5bfa7-1) unstable; urgency=low

  * New upstream release.
  * debian/control
    - (Vcs-*): new fields.
    - (Section): Change from utils to vcs (used by the FTP masters).
  * debian/patches
    - (02 p.help, 30 dotest): remove. Integrated to upstream.
    - (05 Makefile): Adjust for new upstream.

 -- Jari Aalto <jari.aalto@cante.net>  Fri, 05 Mar 2010 09:36:48 +0200

wiggle (0.6-7) unstable; urgency=low

  * New maintainer (Closes: #568575).
    - Move to packaging format "3.0 (quilt)".
  * debian/control
    - (Build-Depends): update to debhelper 7.1.
    - (Depends): add ${misc:Depends}.
    - (Standards-Version): Update to 3.8.4.
  * debian/copyright
    - Update layout.
    - Update download URL (Closes: #515124).
  * debian/dirs
    - Deleted. Not needed.
  * debian/patches
    - Convert inline changes to patches.
  * debian/README.Debian
    - Correct 'perl script' to just script (actually Bourne shell).
    - Remove indication to patches, not relevant for the end-user.
  * debian/rules
    - Update to dh(1).
    - (CFLAGS): Change -Werror to -Wall -pedantic
      (gcc-4.5 FTBFS; Closes: #565074).
  * debian/source/format
    - New file.
  * debian/wiggle.docs
    - New file.
  * debian/wiggle.install
    - New file.

 -- Jari Aalto <jari.aalto@cante.net>  Thu, 04 Mar 2010 18:08:16 +0200

wiggle (0.6-6) unstable; urgency=low

  * Take sole ownership of the package, Nicolas is unresponsive
  * Add Homepage field to control header
  * Change to dh compat level 5
  * Do not ignore errors in make clean
  * Update Standards-Version to 3.7.3, no changes needed
  * Update the FSF address in the debian/copyright file
  * Switch to use the git upstream

 -- Baruch Even <baruch@debian.org>  Sat, 29 Dec 2007 21:22:49 +0200

wiggle (0.6-5) unstable; urgency=low

  * Adopt this package (closes: #233661)
  * Modify build to use dpatch
  * New Standard: 3.6.1.1
      - No need to change
  * Add upstream fixes 004ExtractFix 005Pchanges (006NoDebug is already
    applied)
  * Add the notes files to the documentation

 -- Nicolas Thomas <nthomas@free.fr>  Sat,  4 Dec 2004 22:42:17 +0100

wiggle (0.6-4) unstable; urgency=low

  * Orphan this package

 -- Igor Genibel <igenibel@debian.org>  Thu, 19 Feb 2004 11:07:37 +0100

wiggle (0.6-3) unstable; urgency=low

  * Fix upstream bug (Thanks Jan Hudec <bulb@ucw.cz>)
      - upstream provided a patch
  * New Standard: 3.6.0
      - No need to change

 -- Igor Genibel <igenibel@debian.org>  Sat, 12 Jul 2003 10:39:15 +0200

wiggle (0.6-2) unstable; urgency=low

  * Add new build dependency to groff (Closes: #197994)

 -- Igor Genibel <igenibel@debian.org>  Thu, 19 Jun 2003 09:31:14 +0200

wiggle (0.6-1) unstable; urgency=low

  * Initial Release. (Closes: #196862)

 -- Igor Genibel <igenibel@debian.org>  Tue, 10 Jun 2003 12:24:49 +0200

=== debian/control ===
Source: wiggle
Section: vcs
Priority: optional
Maintainer: Jari Aalto <jari.aalto@cante.net>
Build-Depends: debhelper (>= 7.1), time, groff, libncurses5-dev
Standards-Version: 3.8.4
Vcs-Browser: http://git.debian.org/?p=collab-maint/wiggle.git
Vcs-Git: git://git.debian.org/git/collab-maint/wiggle.git
Homepage: http://cgi.cse.unsw.edu.au/~neilb/source/wiggle/

Package: wiggle
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: a program for applying patches with conflicting changes
 Wiggle is a program for applying patches that 'patch' cannot
 apply due to conflicting changes in the original.
 .
 Wiggle will always apply all changes in the patch to the original.
 If it cannot find a way to cleanly apply a patch, it inserts it
 in the original in a manner similar to 'merge', and report an
 unresolvable conflict.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

CFLAGS_EXTRA = -Wall -pedantic
CC	     = gcc

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_auto_build:
	$(MAKE) CC="$(CC)" CFLAGS="$(CFLAGS) $(CFLAGS_EXTRA)"

%:
	dh $@

# End of file

=== debian/watch ===
version=3
http://neil.brown.name/wiggle/ .*wiggle-([\d.]+).tar.gz

## wiggle 0.8+dfsg1

=== Makefile ===
--- 
+++ 
@@ -12,12 +12,14 @@
 MANDIR  = /usr/share/man
 MAN1DIR = $(MANDIR)/man1
 MAN5DIR = $(MANDIR)/man5
+LDLIBS = -lncurses
 
 all: wiggle wiggle.man test
 
-
-wiggle : wiggle.o load.o split.o extract.o diff.o bestmatch.o ReadMe.o merge.o
-wiggle.o load.o split.o extract.o diff.o bestmatch.o ReadMe.o merge.o : wiggle.h
+wiggle : wiggle.o load.o split.o extract.o diff.o bestmatch.o ReadMe.o \
+              merge.o merge2.o vpatch.o
+wiggle.o load.o split.o extract.o diff.o bestmatch.o ReadMe.o merge.o \
+               merge2.o vpatch.o : wiggle.h
 
 test: wiggle dotest
 	sh dotest
@@ -26,7 +28,7 @@
 	nroff -man wiggle.1 > wiggle.man
 
 clean:
-	rm -f *.o *.man wiggle .version* version
+	rm -f *.o *.man wiggle .version* demo.patch
 	find . -name core -o -name '*.tmp*' -o -name .tmp | xargs rm -f
 
 install : wiggle wiggle.1
@@ -48,3 +50,6 @@
 
 v : version
 	cat version
+
+demo.patch:
+	diff -ru demo.orig demo.patched | sed 's/demo.patched/demo/' > demo.patch

=== .patches/current/Makefile ===

# Note on my Mobile Pentium II, -march=pentium2 delivers twice the performance of i386
#OptDbg=-O3
#OptDbg=-O3 -march=pentium2
OptDbg=-ggdb
CFLAGS=$(OptDbg) -Wall -Werror

# STRIP = -s
INSTALL = /usr/bin/install
DESTDIR = 
BINDIR  = /usr/bin
MANDIR  = /usr/share/man
MAN1DIR = $(MANDIR)/man1
MAN5DIR = $(MANDIR)/man5
LDLIBS = -lncurses

all: wiggle wiggle.man test

wiggle : wiggle.o load.o split.o extract.o diff.o bestmatch.o ReadMe.o \
              merge.o merge2.o vpatch.o
wiggle.o load.o split.o extract.o diff.o bestmatch.o ReadMe.o merge.o \
               merge2.o vpatch.o : wiggle.h

test: wiggle dotest
	sh dotest

wiggle.man : wiggle.1
	nroff -man wiggle.1 > wiggle.man

clean:
	rm -f *.o *.man wiggle .version* version
	find . -name core -o -name '*.tmp*' -o -name .tmp | xargs rm -f

install : wiggle wiggle.1
	$(INSTALL) -D $(STRIP) -m 755 wiggle $(DESTDIR)$(BINDIR)/wiggle
	$(INSTALL) -D -m 644 wiggle.1 $(DESTDIR)$(MAN1DIR)/wiggle.1

version : ReadMe.c wiggle.1
	@rm -f version
	@sed -n -e 's/.*wiggle - v\([0-9.]*\) - .*/\1/p' ReadMe.c > .version-readme
	@sed -n -e 's/.*WIGGLE 1 "" v\([0-9.]*\)$$/\1/p' wiggle.1 > .version-man
	@cmp -s .version-readme .version-man && cat .version-man > version || { echo Inconsistant versions.; exit 1;}

dist : test clean version
	mkdir -p DIST
	rm -f DIST/wiggle-`cat version`
	ln -s .. DIST/wiggle-`cat version`
	tar czvf DIST/wiggle-`cat version`.tar.gz -h -C DIST --exclude RCS --exclude DIST wiggle-`cat version`
	rm -f DIST/wiggle-`cat version`

v : version
	cat version

demo.patch:
	diff -ru demo.orig demo.patched | sed 's/demo.patched/demo/' > demo.patch

=== debian/changelog ===
wiggle (0.8+dfsg1-1) unstable; urgency=low

  * Repackage upstream tarball: remove .git and non-free *.ps
    documentation about used algorithm (Closes: #698846). Upstream
    has removed the file in the next release.
  * debian/control
    - (Standards-Version): Update to 3.9.4.
  * debian/copyright
    - Update year.
  * debian/docs
    - Add missing newline to the last line.
  * debian/wiggle.docs
    - Delete file due to #698846. There is already debian/docs.

 -- Jari Aalto <jari.aalto@cante.net>  Wed, 20 Feb 2013 12:12:10 +0200

wiggle (0.8-2) unstable; urgency=low

  * debian/control
    - (Build-Depends): Update to debhelper 9. Add libncurses5-dev.
    - (Description): Adjust first line.
    - (Standards-Version): Update to 3.9.3.1.
  * debian/copyright
    - Update to format 1.0.
  * debian/rules
    - (override_dh_*_clean): New. Save and restore original files.
    - Use hardened build flags
      http://wiki.debian.org/ReleaseGoals/SecurityHardeningBuildFlags

 -- Jari Aalto <jari.aalto@cante.net>  Sat, 24 Mar 2012 06:07:32 -0400

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: vcs
 Priority: optional
 Maintainer: Jari Aalto <jari.aalto@cante.net>
-Build-Depends: debhelper (>= 7.1), time, groff, libncurses5-dev
-Standards-Version: 3.8.4
+Build-Depends: debhelper (>= 9), time, groff, libncurses5-dev
+Standards-Version: 3.9.4
 Vcs-Browser: http://git.debian.org/?p=collab-maint/wiggle.git
 Vcs-Git: git://git.debian.org/git/collab-maint/wiggle.git
 Homepage: http://cgi.cse.unsw.edu.au/~neilb/source/wiggle/
@@ -11,7 +11,7 @@
 Package: wiggle
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Description: a program for applying patches with conflicting changes
+Description: apply patches with conflicting changes
  Wiggle is a program for applying patches that 'patch' cannot
  apply due to conflicting changes in the original.
  .

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS	= hardening=+all
export DEB_CFLAGS_MAINT_APPEND	= -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

override_dh_auto_clean:
	# Save original files
	tar -cf saved.tar .version-man .version-readme TAGS
	dh_auto_clean

override_dh_clean:
	dh_clean
	# Restore original files
	tar -xf saved.tar ; rm saved.tar

override_dh_auto_build:
	$(MAKE) CFLAGS="$(CFLAGS) $(CPPFLAGS) $(LDFLAGS)"

%:
	dh $@

# End of file

=== debian/watch ===
version=3
# 2010-03-04 No upstream URL

## wiggle 0.9.1

=== Makefile ===

# Note on my Mobile Pentium II, -march=pentium2 delivers twice the performance of i386
#OptDbg=-O3
#OptDbg=-O3 -march=pentium2
OptDbg=-ggdb
CFLAGS=$(OptDbg) -I. -Wall -Werror -Wstrict-prototypes -Wextra -Wno-unused-parameter

# STRIP = -s
INSTALL = /usr/bin/install
DESTDIR = 
BINDIR  = /usr/bin
MANDIR  = /usr/share/man
MAN1DIR = $(MANDIR)/man1
MAN5DIR = $(MANDIR)/man5
LDLIBS = -lncurses

all: wiggle wiggle.man test

wiggle : wiggle.o load.o parse.o split.o extract.o diff.o bestmatch.o ReadMe.o \
              merge2.o vpatch.o ccan/hash/hash.o
wiggle.o load.o parse.o split.o extract.o diff.o bestmatch.o ReadMe.o \
               merge2.o vpatch.o :: wiggle.h
split.o :: ccan/hash/hash.h config.h


test: wiggle dotest
	./dotest

wiggle.man : wiggle.1
	nroff -man wiggle.1 > wiggle.man

clean:
	rm -f *.o ccan/hash/*.o *.man wiggle .version* demo.patch version
	find . -name core -o -name '*.tmp*' -o -name .tmp -o -name .time | xargs rm -f

install : wiggle wiggle.1
	$(INSTALL) -D $(STRIP) -m 755 wiggle $(DESTDIR)$(BINDIR)/wiggle
	$(INSTALL) -D -m 644 wiggle.1 $(DESTDIR)$(MAN1DIR)/wiggle.1

version : ReadMe.c wiggle.1
	@rm -f version
	@sed -n -e 's/.*wiggle \([0-9.]*\) .*/\1/p' ReadMe.c > .version-readme
	@sed -n -e 's/.*WIGGLE 1 "" v\([0-9.]*\)$$/\1/p' wiggle.1 > .version-man
	@cmp -s .version-readme .version-man && cat .version-man > version || { echo Inconsistant versions.; exit 1;}

dist : test clean version
	mkdir -p DIST
	rm -f DIST/wiggle-`cat version`
	git archive --prefix wiggle-`cat version`/  v`cat version` | gzip -9 > DIST/wiggle-`cat version`.tar.gz

v : version
	cat version

demo.patch: force
	diff -ru demo.orig demo.patched | sed 's/demo.patched/demo/' > demo.patch

force:

=== debian/changelog ===
wiggle (0.9.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix big-endian FTBFS (Closes: #733831)

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 06 Jan 2014 05:16:36 +0000

wiggle (0.9.1-1) unstable; urgency=low

  * New upstream release
    - Non-DSFG file DOC/diff.ps no longer included. See bug #698846.
  * debian/install
    - Rename from debian/wiggle.install.
  * debian/patches:
    - (10): Rm. Fix for a type in ReadMe.c accepted upstream.
    - (20): New. Correct hyphen in manual page.
  * debian/watch
    - Add URL to check new releases. Thanks to Bart Martens
      <bartm@debian.org>.

 -- Jari Aalto <jari.aalto@cante.net>  Thu, 23 May 2013 20:30:58 +0300

wiggle (0.8+dfsg1-2) unstable; urgency=low

  * debian/control
    - (Homepage): Update broken URL to Freecode (Closes: #699715).
  * debian/copyright
    - Update upstream URL locations. See above bug.

 -- Jari Aalto <jari.aalto@cante.net>  Thu, 28 Feb 2013 10:59:53 +0200

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Standards-Version: 3.9.4
 Vcs-Browser: http://git.debian.org/?p=collab-maint/wiggle.git
 Vcs-Git: git://git.debian.org/git/collab-maint/wiggle.git
-Homepage: http://cgi.cse.unsw.edu.au/~neilb/source/wiggle/
+Homepage: http://freecode.com/projects/wiggle
 
 Package: wiggle
 Architecture: any

## wiggle 1.0+20140408+git920f58a

=== Makefile ===

# Note on my Mobile Pentium II, -march=pentium2 delivers twice the performance of i386
#OptDbg=-O3
#OptDbg=-O3 -march=pentium2
OptDbg=-ggdb
ifndef CWFLAGS
CWFLAGS=-Wall -Werror -Wstrict-prototypes -Wextra -Wno-unused-parameter -Wno-missing-field-initializers
endif
CFLAGS=$(OptDbg) -I. $(CWFLAGS)

# STRIP = -s
INSTALL = /usr/bin/install -D
DESTDIR =
BINDIR  = /usr/bin
MANDIR  = /usr/share/man
MAN1DIR = $(MANDIR)/man1
MAN5DIR = $(MANDIR)/man5
LDLIBS = -lncurses

all: wiggle wiggle.man test

wiggle : wiggle.o load.o parse.o split.o extract.o diff.o bestmatch.o ReadMe.o \
              merge2.o vpatch.o ccan/hash/hash.o
wiggle.o load.o parse.o split.o extract.o diff.o bestmatch.o \
               merge2.o vpatch.o :: wiggle.h
split.o :: ccan/hash/hash.h config.h

VERSION = $(shell [ -d .git ] && git 2> /dev/null describe HEAD)
VERS_DATE = $(shell [ -d .git ] && git 2> /dev/null log -n1 --format=format:%cd --date=short)
DVERS = $(if $(VERSION),-DVERSION=\"$(VERSION)\",)
DDATE = $(if $(VERS_DATE),-DVERS_DATE=\"$(VERS_DATE)\",)
CFLAGS += $(DVERS) $(DDATE)

test: wiggle dotest
	./dotest

valgrind: wiggle dotest
	./dotest valgrind

vtest: wiggle dovtest
	./dovtest

wiggle.man : wiggle.1
	nroff -man wiggle.1 > wiggle.man

clean:
	rm -f *.o ccan/hash/*.o *.man wiggle .version* demo.patch version
	find . -name core -o -name '*.tmp*' -o -name .tmp -o -name .time | xargs rm -f

install : wiggle wiggle.1
	$(INSTALL) $(STRIP) -m 755 wiggle $(DESTDIR)$(BINDIR)/wiggle
	$(INSTALL) -m 644 wiggle.1 $(DESTDIR)$(MAN1DIR)/wiggle.1

version : ReadMe.c wiggle.1
	@rm -f version
	@sed -n -e 's/.*VERSION "\([0-9.]*\)".*/\1/p' ReadMe.c > .version-readme
	@sed -n -e 's/.*WIGGLE 1 "" v\([0-9.]*\)$$/\1/p' wiggle.1 > .version-man
	@cmp -s .version-readme .version-man && cat .version-man > version || { echo Inconsistant versions.; exit 1;}

dist : test clean version
	mkdir -p DIST
	rm -f DIST/wiggle-`cat version`
	git archive --prefix wiggle-`cat version`/  v`cat version` | gzip -9 > DIST/wiggle-`cat version`.tar.gz

v : version
	cat version

demo.patch: force
	diff -rup demo.orig demo.patched | sed 's/demo.patched/demo/' > demo.patch

force:

=== debian/changelog ===
wiggle (1.0+20140408+git920f58a-2) unstable; urgency=medium

  * debian/control
    - (Homepage): Update.
    - (Standards-Version): Update to 3.9.8.
    - (Vcs-*): Update to anonscm.debian.org.
  * debian/copyright
    - Update URLs.

 -- Jari Aalto <jari.aalto@cante.net>  Thu, 20 Oct 2016 17:51:23 +0300

wiggle (1.0+20140408+git920f58a-1) unstable; urgency=low

  * New upstream release (Closes: #736893).
    - 0.9.1-1.1 FTBFS fix included.
  * debian/control
    - (Standards-Version): 3.9.5
    - (Vcs-*): Update to anonscm.debian.org.
  * debian/copyright
    - Update years.
  * debian/patches
    - Rm, manual page fixes included upstream.

 -- Jari Aalto <jari.aalto@cante.net>  Tue, 08 Apr 2014 10:16:48 +0300

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Priority: optional
 Maintainer: Jari Aalto <jari.aalto@cante.net>
 Build-Depends: debhelper (>= 9), time, groff, libncurses5-dev
-Standards-Version: 3.9.4
-Vcs-Browser: http://git.debian.org/?p=collab-maint/wiggle.git
-Vcs-Git: git://git.debian.org/git/collab-maint/wiggle.git
-Homepage: http://freecode.com/projects/wiggle
+Standards-Version: 3.9.8
+Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/wiggle.git
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/wiggle.git
+Homepage: http://neil.brown.name/wiggle
 
 Package: wiggle
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS	= hardening=+all
export DEB_CFLAGS_MAINT_APPEND	= -Wall -pedantic -I.
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

override_dh_auto_build:
	$(MAKE) CFLAGS="$(CFLAGS) $(CPPFLAGS) $(LDFLAGS)"

%:
	dh $@

# End of file

## wiggle 1.1

=== Makefile ===
--- 
+++ 
@@ -8,11 +8,12 @@
 endif
 CFLAGS=$(OptDbg) -I. $(CWFLAGS)
 
+PREFIX  = /usr
 # STRIP = -s
-INSTALL = /usr/bin/install -D
+INSTALL = /usr/bin/install
 DESTDIR =
-BINDIR  = /usr/bin
-MANDIR  = /usr/share/man
+BINDIR  = $(PREFIX)/bin
+MANDIR  = $(PREFIX)/share/man
 MAN1DIR = $(MANDIR)/man1
 MAN5DIR = $(MANDIR)/man5
 LDLIBS = -lncurses
@@ -48,8 +49,9 @@
 	find . -name core -o -name '*.tmp*' -o -name .tmp -o -name .time | xargs rm -f
 
 install : wiggle wiggle.1
-	$(INSTALL) $(STRIP) -m 755 wiggle $(DESTDIR)$(BINDIR)/wiggle
-	$(INSTALL) -m 644 wiggle.1 $(DESTDIR)$(MAN1DIR)/wiggle.1
+	$(INSTALL) -d $(DESTDIR)$(BINDIR) $(DESTDIR)$(MAN1DIR)
+	$(INSTALL) $(STRIP) -m 755 wiggle $(DESTDIR)$(BINDIR)
+	$(INSTALL) -m 644 wiggle.1 $(DESTDIR)$(MAN1DIR)
 
 version : ReadMe.c wiggle.1
 	@rm -f version

=== demo.patched/Makefile ===

# Note on my Mobile Pentium II, -march=pentium2 delivers twice the performance of i386
#OptDbg=-O3
#OptDbg=-O3 -march=pentium2
OptDbg=-ggdb
CFLAGS=$(OptDbg) -Wall -Werror

# STRIP = -s
INSTALL = /usr/bin/install
DESTDIR = 
BINDIR  = /usr/bin
MANDIR  = /usr/share/man
MAN1DIR = $(MANDIR)/man1
MAN5DIR = $(MANDIR)/man5
LDLIBS=-lncurses

all: wiggle wiggle.man test

vpatch : vpatch.o extract.o split.o diff.o


wiggle : wiggle.o load.o split.o extract.o diff.o bestmatch.o ReadMe.o merge.o
wiggle.o load.o split.o extract.o diff.o bestmatch.o ReadMe.o merge.o : wiggle.h

test: wiggle dotest
	sh dotest

wiggle.man : wiggle.1
	nroff -man wiggle.1 > wiggle.man

clean:
	rm -f *.o *.man wiggle .version* version
	find . -name core -o -name '*.tmp*' -o -name .tmp | xargs rm -f

install : wiggle wiggle.1
	$(INSTALL) -D $(STRIP) -m 755 wiggle $(DESTDIR)$(BINDIR)/wiggle
	$(INSTALL) -D -m 644 wiggle.1 $(DESTDIR)$(MAN1DIR)/wiggle.1

version :  wiggle.1
	@rm -f version
	@sed -n -e 's/.*wiggle - v\([0-9.]*\) - .*/\1/p' ReadMe.c > .version-readme
	@sed -n -e 's/.*WIGGLE 1 "" v\([0-9.]*\)$$/\1/p' wiggle.1 > .version-man
	@cmp -s .version-readme .version-man && cat .version-man > version || { echo Inconsistant versions.; exit 1;}

dist :  clean version
	mkdir -p DIST
	rm -f DIST/wiggle-`cat version`
	ln -s .. DIST/wiggle-`cat version`
	tar czvf DIST/wiggle-`cat version`.tar.gz -h -C DIST --exclude RCS --exclude DIST wiggle-`cat version`
	rm -f DIST/wiggle-`cat version`

v : version
	cat version

demo.patch:
	diff -ru demo.orig demo.patched | sed 's/demo.patched/demo/' > demo.patch

=== demo/Makefile ===
# Note on my Mobile Pentium II, -march=pentium2 delivers twice the performance of i386
#OptDbg=-O3
#OptDbg=-O3 -march=pentium2
CFLAGS=$(OptDbg) -Wall -Werror

# STRIP = 
INSTALL = /usr/bin/install
DESTDIR = 
BINDIR  = /usr/bin
MANDIR  = /var/share/man
MAN1DIR = $(MANDIR)/man1
MAN5DIR = $(MANDIR)/man5
LDLIBS=-lncurses

all: wiggle wiggle.man test

vpatch : vpatch.o extract.o split.o diff.o


# comment
wiggle : wiggle.o load.o split.o extract.o diff.o bestmatch.o ReadMe.o merge.o
wiggle.o load.o split.o extract.o diff.o bestmatch.o ReadMe.o merge.o : wiggle.h

test: wiggle dotest
	sh dotest

wiggle.man : wiggle.1
	nroff -man wiggle.1 > wiggle.man

clean:
	rm -f *.o *.man wiggle .version* version
	find . -name core -o -name '*.tmp*' -o -name .tmp | xargs rm -f

install : wiggle wiggle.1
	$(INSTALL) -D $(STRIP) -m 755 wiggle $(DESTDIR)$(BINDIR)/wiggle
	$(INSTALL) -D -m 644 wiggle.1 $(DESTDIR)$(MAN1DIR)/wiggle.1

version : ReadMe.c wiggle.1 Readme.c
	@rm -f version
	@sed -n -e 's/.*wiggle - v\([0-9.]*\) - .*/\1/p' ReadMe.c > .version-readme
	@sed -n -e 's/.*WIGGLE 1 "" v\([0-9.]*\)$$/\1/p' wiggle.1 > .version-man
	@cmp -s .version-readme .version-man && cat .version-man > version || { echo Inconsistant versions.; exit 1;}

dist : test clean version Test
	mkdir -p DIST
	rm -f DIST/wiggle-`cat version`
	ln -s .. DIST/wiggle-`cat version`
	tar czvf DIST/wiggle-`cat version`.tar.gz -h -C DIST --exclude RCS --exclude DIST wiggle-`cat version`
	rm -f DIST/wiggle-`cat version`

v : version
	cat version

=== debian/changelog ===
wiggle (1.1-1) unstable; urgency=medium

  * QA upload.
  * Set Maintainer to Debian QA Group. (See: #920082)
  * New upstream release [1.1].
  * Update B-D: libncurses5-dev -> libncurses-dev.
  * Build with Debhelper compat level 12.
  * Update VCS details.
  * Set "Rules-Requires-Root: no".
  * Perform wrap-and-sort on Debian source files.
  * Update upstream URLs.
  * Suppress debian-watch-does-not-check-gpg-signature lintian warning.
  * Add machine-readable upstream metadata.
  * Build verbosely and with LFS support.
  * Update debian/copyright.
  * Add typos.patch to fix some typos.
  * Add debian/gbp.conf.
  * Add gcc8-format-security.patch to fix format overflow and truncation
    warnings.
  * Relax pedantic GCC warnings, as well as warnings about unused result.
  * Indicate compliance with Debian Policy 4.3.0.
  * Indicate that the package enhances git.

 -- Carlos Maddela <e7appew@gmail.com>  Fri, 25 Jan 2019 12:17:13 +1100

=== debian/control ===
Source: wiggle
Section: vcs
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper (>= 12), groff, libncurses-dev, time
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/debian/wiggle
Vcs-Git: https://salsa.debian.org/debian/wiggle.git
Homepage: https://neil.brown.name/wiggle
Rules-Requires-Root: no

Package: wiggle
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Enhances: git
Description: apply patches with conflicting changes
 Wiggle is a program for applying patches that 'patch' cannot
 apply due to conflicting changes in the original.
 .
 Wiggle will always apply all changes in the patch to the original.
 If it cannot find a way to cleanly apply a patch, it inserts it
 in the original in a manner similar to 'merge', and report an
 unresolvable conflict.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS	= hardening=+all future=+lfs
export DEB_CFLAGS_MAINT_APPEND	= -Wall -Wno-unused-result -I.
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- CFLAGS="$(CFLAGS) $(CPPFLAGS) $(LDFLAGS)"

## wiggle 1.3

=== Makefile ===
--- 
+++ 
@@ -18,13 +18,46 @@
 MAN5DIR = $(MANDIR)/man5
 LDLIBS = -lncurses
 
-all: wiggle wiggle.man test
+# Where to place intermediate objects
+O=O
+# Where to place final objects
+BIN=.
+DOC=.
 
-wiggle : wiggle.o load.o parse.o split.o extract.o diff.o bestmatch.o ReadMe.o \
-              merge2.o vpatch.o ccan/hash/hash.o
-wiggle.o load.o parse.o split.o extract.o diff.o bestmatch.o \
-               merge2.o vpatch.o :: wiggle.h
-split.o :: ccan/hash/hash.h config.h
+LIBOBJ= load.o parse.o split.o extract.o diff.o bestmatch.o merge2.o utils.o ccan/hash/hash.o
+OBJ=wiggle.o ReadMe.o vpatch.o
+
+BOBJ=$(patsubst %.o,$(O)/%.o,$(OBJ))
+BLIBOBJ=$(patsubst %.o,$(O)/%.o,$(LIBOBJ))
+
+all: $(BIN)/wiggle $(DOC)/wiggle.man test
+lib : $(O)/libwiggle.a
+
+#
+# Pretty print
+#
+V	      = @
+Q	      = $(V:1=)
+QUIET_CC      = $(Q:@=@echo    '     CC       '$@;)
+QUIET_AR      = $(Q:@=@echo    '     AR       '$@;)
+QUIET_LINK    = $(Q:@=@echo    '     LINK     '$@;)
+QUIET_MAN     = $(Q:@=@echo    '     MAN      '$@;)
+QUIET_CLEAN   = $(Q:@=@echo    '     CLEAN    '$@;)
+
+
+$(BIN)/wiggle : $(BOBJ) $(O)/libwiggle.a
+	$(QUIET_LINK)$(CC) $(CFLAGS) $^ $(LDLIBS) -o $@
+
+$(O)/libwiggle.a : $(BLIBOBJ)
+	$(QUIET_AR)ar cr $@ $^
+
+$(BOBJ) :: wiggle.h
+
+$(O)/split.o :: ccan/hash/hash.h config.h
+
+$(BOBJ) $(BLIBOBJ) :: $(O)/%.o : %.c
+	@mkdir -p $(dir $@)
+	$(QUIET_CC)$(CC) $(CFLAGS) -c -o $@ $<
 
 VERSION = $(shell [ -d .git ] && git 2> /dev/null describe HEAD)
 VERS_DATE = $(shell [ -d .git ] && git 2> /dev/null log -n1 --format=format:%cd --date=short)
@@ -41,16 +74,21 @@
 vtest: wiggle dovtest
 	./dovtest
 
-wiggle.man : wiggle.1
-	nroff -man wiggle.1 > wiggle.man
+$(DOC)/wiggle.man : wiggle.1
+	$(QUIET_MAN)nroff -man wiggle.1 > $@
 
-clean:
-	rm -f *.o ccan/hash/*.o *.man wiggle .version* demo.patch version
-	find . -name core -o -name '*.tmp*' -o -name .tmp -o -name .time | xargs rm -f
+clean: targets artifacts dirs
+targets:
+	$(QUIET_CLEAN)rm -f $(O)/*.[ao] $(O)/ccan/hash/*.o $(DOC)/*.man $(BIN)/wiggle .version* demo.patch version
+artifacts:
+	$(QUIET_CLEAN)find . -name core -o -name '*.tmp*' -o -name .tmp -o -name .time | xargs rm -f
+dirs : targets artifacts
+	$(QUIET_CLEAN)[ -d $(O)/ccan/hash ] && rmdir -p $(O)/ccan/hash || true
+	$(QUIET_CLEAN)[ -d $(O) ] && rmdir -p $(O) || true
 
-install : wiggle wiggle.1
+install : $(BIN)/wiggle wiggle.1
 	$(INSTALL) -d $(DESTDIR)$(BINDIR) $(DESTDIR)$(MAN1DIR)
-	$(INSTALL) $(STRIP) -m 755 wiggle $(DESTDIR)$(BINDIR)
+	$(INSTALL) $(STRIP) -m 755 $(BIN)/wiggle $(DESTDIR)$(BINDIR)
 	$(INSTALL) -m 644 wiggle.1 $(DESTDIR)$(MAN1DIR)
 
 version : ReadMe.c wiggle.1

=== debian/changelog ===
wiggle (1.3-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Wed, 14 Feb 2024 13:54:18 -0500

wiggle (1.2-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.
  * debian/patches: Dropped, merged upstream.
  * Bump debhelper compat to v13.
  * debian/gbp.conf: Relax branch requirements.
  * debian/rules: Drop unnecessary --as-needed parameter.
  * debian/upstream/metadata: Drop deprecated fields.

 -- Boyuan Yang <byang@debian.org>  Sun, 01 Oct 2023 12:09:14 -0400

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: vcs
 Priority: optional
 Maintainer: Debian QA Group <packages@qa.debian.org>
-Build-Depends: debhelper (>= 12), groff, libncurses-dev, time
-Standards-Version: 4.3.0
+Build-Depends: debhelper-compat (= 13), groff, libncurses-dev, time
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian/wiggle
 Vcs-Git: https://salsa.debian.org/debian/wiggle.git
 Homepage: https://neil.brown.name/wiggle

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 export DEB_BUILD_MAINT_OPTIONS	= hardening=+all future=+lfs
 export DEB_CFLAGS_MAINT_APPEND	= -Wall -Wno-unused-result -I.
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
+export DEB_LDFLAGS_MAINT_APPEND =
 
 %:
 	dh $@

=== debian/watch ===
version=3
https://neil.brown.name/wiggle/wiggle-(\d.*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
